



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS开发--隐藏（去除）导航栏底部横线</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS开发--隐藏（去除）导航栏底部横线</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 03:09:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>iOS开发大部分情况下会使用到导航栏，由于我司的app导航栏需要与下面紧挨着的窗口颜色一致，导航栏底部的横线就会影响这个美观，LZ使用了以下方法。觉得不错，分享来给小伙伴们。</p>
<hr />
<p>1）声明UIImageView变量,存储底部横线</p>
<pre class="prettyprint linenums"><code>@interface MyViewController {<br />
    UIImageView *navBarHairlineImageView;<br />
}</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li></ul>
<p>2）在viewDidLoad中加入：</p>
<pre class="prettyprint linenums"><code>navBarHairlineImageView = [self findHairlineImageViewUnder:self.navigationController.navigationBar];</code></pre>
<ul><li>1</li></ul>
<p>3）实现找出底部横线的函数</p>
<pre class="prettyprint linenums"><code>- (UIImageView *)findHairlineImageViewUnder:(UIView *)view {<br />
    if ([view isKindOfClass:UIImageView.class] &amp;&amp; view.bounds.size.height &lt;= 1.0) {<br />
            return (UIImageView *)view;<br />
    }<br />
    for (UIView *subview in view.subviews) {<br />
        UIImageView *imageView = [self findHairlineImageViewUnder:subview];<br />
        if (imageView) {<br />
            return imageView;<br />
        }<br />
    }<br />
    return nil;<br />
}</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li>
<li>10</li>
<li>11</li>
<li>12</li></ul>
<p>4）最后在viewWillAppear，viewWillDisappear中处理</p>
<pre class="prettyprint linenums"><code>- (void)viewWillAppear:(BOOL)animated {<br />
    [super viewWillAppear:animated];<br />
    navBarHairlineImageView.hidden = YES;<br />
}

- (void)viewWillDisappear:(BOOL)animated {<br />
    [super viewWillDisappear:animated];<br />
    navBarHairlineImageView.hidden = NO;<br />
}</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li>
<li>9</li></ul>
<hr />
<hr />
<p>上面使用了一种个人比较喜欢的方法，</p>
<h3>下面来一个最简单的：</h3>
<hr />
<p>的。</p>
<pre class="prettyprint linenums"><code>UINavigationBar *navigationBar = self.navigationController.navigationBar;<br />
// bg.png为自己ps出来的想要的背景颜色。<br />
[navigationBar setBackgroundImage:[UIImage imageNamed:@"bg.png"]<br />
                   forBarPosition:UIBarPositionAny<br />
                       barMetrics:UIBarMetricsDefault];<br />
[navigationBar setShadowImage:[UIImage new]];</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li></ul>
<p>这是唯一一个隐藏这条线的官方用法，但是有一个缺陷-删除了translucency(半透明)</p>
<hr />
<p>总体来说，第二种办法还是很好地，建议大家使用第二种办法。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k14r39.html">sql语句-备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/495wnde9.html">uva 10820</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mkk4pq.html">Python自动化 【第十六篇】：JavaScript作用域和Dom收尾</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rrjvd9.html">java 线程的堵塞</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnej0d8.html">MPlayerX For Mac白屏问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnyzyv8.html">html5 标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdkm4m8.html">kettle作业（job）调用转换，设置变量，写日志到数据库中【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xedv9.html">表达式求职JAVA（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxlxm8.html">使用jqMobi开发app基础：Badge的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zognzvq.html">富文本编辑器 - wangEditor 上传图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gemjy78.html">树状DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1krgjz9.html">计算机就是用命换的行业&comma;多干一年程序猿&comma;寿命将减少2年&comma;干20年的编程苦力&comma;基本60岁之前你就要OVER了</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd21g79.html">Web应用与应用层协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyv24k9.html">Capability配置简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e41ggj9.html">linux tee</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5v414q.html">Boost--optional</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2gxwo9.html">MySQL安全策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpde3z9.html">Oracle 使用GSON库解析复杂json串</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e2j0j9.html">Axure响应式进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/902566oq.html">&lbrack;转载&rsqb;Java抽象类和接口的学习</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m96ex5vq.html">Linux高级编程--11&period;信号</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j3kxeq.html">DDD：建模原语 之 四象图（转载的神文）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pr1x4q.html">Hadoop入门进阶课程12--Flume介绍、安装与应用案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw27yyq.html">Pop - Facebook 开源 iOS &amp;amp&semi; OS X 动画库</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw3kpz9.html">Action接收页面传来的参数方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z0onnq.html">MyBatis动态SQL使用，传入参数Map中的Key判断</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m12vo8.html">C&num;设计模式&mdash;&mdash;原型模式&lpar;Prototype Pattern&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2pk5l8.html">SQLServer根据不同前缀生成多套流水号</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq11pv4q.html">LeetCode2：Median of Two Sorted Arrays</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4ln458.html">Linux服务器时间同步方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
